%global product_family Red Hat Enterprise Virtualization Hypervisor
%global product_release 7.2 (0)
%global mgmt_scripts_dir %{_sysconfdir}/node.d
%global dist .el7ev
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%define is_fedora_systemd %(test 0%{?fedora} -ne 0 && test %{?fedora} -ge 16 && echo 1 || echo 0)
%define is_rhel_systemd %(test 0%{?rhel} -ne 0 && test %{?rhel} -ge 7 && echo 1 || echo 0)
%define is_centos_systemd %(test 0%{?centos} -ne 0 && test %{?centos} -ge 7 && echo 1 || echo 0)
%define is_systemd %( test %{is_rhel_systemd} -eq 1 || test %{is_centos_systemd} = 1 || test %{is_fedora_systemd} = 1 && echo 1 || echo 0)
%define dracutdir %(test -e /usr/share/dracut && echo "/usr/share/dracut/modules.d" || echo "/usr/lib/dracut/modules.d")
%define is_el7 %(test 0%{?centos} -eq 07 || test 0%{?rhel} -eq 07 && echo 1 || echo 0)

# RHN Plugin is only build on RHEL
%define with_rhn 0%{?rhel}


%global use_snapshot_release 0
%global snapshot .20160113
%global commit 7c01f7c037d53e7da4cae75e016636c3dafccc72
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global checkout %{?snapshot}git%{shortcommit}

Summary:        The %{product_family} daemons/scripts
Name:           ovirt-node
Version:        3.6.1
%if 0%{?use_snapshot_release}
Release:        0.0%{?checkout}%{?dist}
%else
Release:        8.0%{?dist}
%endif
Source0:        https://gerrit.ovirt.org/gitweb?p=%{name}.git;a=snapshot;h=%{commit};sf=tgz#/%{name}-%{version}%{?checkout}.tar.gz

Source1:        rhev-syslinux-vesa-splash.png
# Product key for RHN, from http://git.app.eng.bos.redhat.com/git/rcm/rcm-metadata.git/plain/product_ids/rhev-3.6/
Source2:        RHEV-x86_64-fcf7726b7902-150.pem

# d/s git: https://code.engineering.redhat.com/gerrit/gitweb?p=ovirt-node.git
# Export patches from d/s git:
#   git --git-dir ~/work/rhev/gerrit/ovirt-node/.git format-patch -o ~/rhpkg/ovirt-node/ --start-number $((`ls *.patch | wc -l` + 1)) ovirt-node-3.2.1-LAST..rhev-3.5
# Update the patches in this specifle: PatchX and %patchX lines can automatically be updated by calling:
#   update-patches-in-spec.sh
#
# Patch1: ….patch
#Patch-marker
Patch1: 0001-Bring-back-EFI-support.patch
Patch2: 0002-Bump-to-ovirt-node-3.6.1-4.patch
Patch3: 0003-Bootloader-find-grub-configs-on-EFI.patch
Patch4: 0004-init-Restart-rhel-dmesg-to-ensure-that-var-log-dmesg.patch
Patch5: 0005-Make-the-EFI-CDROM-boot-menu-align-with-legacy-booti.patch
Patch6: 0006-Regenerate-efiboot.img-after-we-write-our-grub-confi.patch
Patch7: 0007-Bump-to-ovirt-node-3.6.1-6.patch
Patch8: 0008-RHN-start-rhsmcertd-in-the-right-place.patch
Patch9: 0009-Bump-to-ovirt-node-3.6.1-7.patch
Patch10: 0010-Revert-Regenerate-efiboot.img-after-we-write-our-gru.patch
Patch11: 0011-Revert-Make-the-EFI-CDROM-boot-menu-align-with-legac.patch
Patch12: 0012-Bump-to-ovirt-node-3.6.1-8.patch


License:        GPLv2+
Group:          Applications/System

URL:            http://www.ovirt.org/
BuildRequires:  python-setuptools python-devel dracut
BuildRequires:  automake autoconf
BuildRequires:  python-lockfile

Requires(post):  /sbin/chkconfig
Requires(preun): /sbin/chkconfig
%if 0%{?is_systemd}
Requires:       systemd-units
Requires(post):     systemd-units
Requires(preun):    systemd-units
Requires:       python-IPy
%endif
Requires:       python-augeas
Requires:       system-release
Requires:       augeas >= 0.3.5
Requires:       bridge-utils
Requires:       udev >= 147-2.34
Requires:       wget
Requires:       cyrus-sasl-gssapi cyrus-sasl >= 2.1.22
Requires:       iscsi-initiator-utils
Requires:       system-config-keyboard-base
Requires:       ntp
Requires:       nfs-utils
Requires:       isomd5sum
Requires:       bash
Requires:       chkconfig
Requires:       bind-utils
Requires:       qemu-img
Requires:       nc
Requires:       /usr/sbin/crond
Requires:       newt-python
Requires:       libuser-python >= 0.56.9
Requires:       dbus-python
Requires:       python-gudev
Requires:       python-urwid
Requires:       python-lockfile
Requires:       python-lxml
Requires:       PyPAM
Requires:       rpm-python
Requires:       ethtool
Requires:       cracklib-python
Requires:       dracut
Requires:       openssh-server
Requires:       hostname
Requires:       tuned
Requires:       NetworkManager
%if 0%{?is_systemd}
Requires:       grub2
%else
Requires:       grub
# for applying patches in % post
Requires(post):       patch
%endif
%if 0%{?is_el7}
Requires:       perf
%endif
Requires:       system-release

#libvirt dependencies
Requires: libvirt-python
%if 0%{?rhel} >= 7 || 0%{?fedora} >= 18
Requires: libvirt-daemon >= 1.0.2-1
Requires: libvirt-daemon-config-nwfilter
Requires: libvirt-daemon-driver-network
Requires: libvirt-daemon-driver-nwfilter
Requires: libvirt-daemon-driver-qemu
%else
%if 0%{?rhel}
Requires: libvirt >= 0.10.2-18.el6_4.4
%else
Requires: libvirt >= 1.0.2-1
%endif
%endif

Requires:       %{name}-selinux = %{version}-%{release}
Requires:       %{name}-branding-rhev = %{version}-%{release}


BuildArch:      noarch

%{!?_licensedir:%global license %%doc}
%define app_root %{_datadir}/%{name}

%description
Provides a series of daemons and support utilities for hypervisor distribution.


%package recipe
Summary:        Recipes for building and running %{product_family} images
Group:          Applications/System
Requires:       pykickstart  >= 1.54
%if 0%{?centos}
Requires:       livecd-tools >= 13.4.4
%else
Requires:       livecd-tools >= 1:16.0
%endif
Obsoletes:      ovirt-node-tools <= 2.3.0-2

%define recipe_root %{_datadir}/ovirt-node-recipe

%description recipe
This package provides recipe (Kickstart files), client tools,
documentation for building and running an %{product_family} image.
This package is not to be installed on the %{product_family},
however on a development machine to help to build the image.


%package tools
Summary:        Tools for working with plugins on %{product_family} images
Group:          Applications/System


%if 0%{?centos}
Requires:       livecd-tools >= 13.4.4
%else
Requires:       livecd-tools >= 1:16.0
%endif
Requires:       libselinux-python

%define tools_root %{_datadir}/ovirt-node-tools

%description tools
This package provides plugin tools for modifying and working with the
%{product_family} image.
This package is not to be installed on the %{product_family},
however on a development machine to work with the image.

%package plugin-ipmi
Summary:        Ipmi plugin for %{product_family} image
Group:          Applications/System
Requires:       ipmitool
Requires:       OpenIPMI

%description plugin-ipmi
This package provides a ipmi plugin for use with %{product_family} image.


#
# oVirt Node plugin SNMP logic
#
%package plugin-snmp-logic
Summary:        SNMP logic for SNMP plugin
Group:          Applications/System
BuildArch:      noarch
Requires:       %{name}-lib = %{version}-%{release}
Requires:       %{name}-lib-config = %{version}-%{release}

%description plugin-snmp-logic
This package provides the snmp logic for snmp plugin

%package plugin-snmp
Summary:        SNMP plugin for %{product_family} image
Group:          Applications/System
Requires:       net-snmp
Requires:       net-snmp-utils
Requires:       perl-libs
Requires:       %{name}-plugin-snmp-logic = %{version}-%{release}

%define snmp_root %{_datadir}/%{name}

%description plugin-snmp
This package provides an snmp plugin tools for use with%{product_family} image.

%post plugin-snmp
%if 0%{?is_systemd}
systemctl enable snmpd.service
%else
chkconfig snmpd on
%endif

cat > /etc/snmp/snmpd.conf << \EOF_snmpd
master agentx
dontLogTCPWrappersConnects yes
rwuser root auth .1
EOF_snmpd

#
# oVirt Node plugin CIM logic
#
%package plugin-cim-logic
Summary:        CIM logic for the CIM plugin
Group:          Applications/System
BuildArch:      noarch
Requires:       %{name}-lib = %{version}-%{release}
Requires:       %{name}-lib-config = %{version}-%{release}
Requires:       %{name}-lib-legacy = %{version}-%{release}

%description plugin-cim-logic
This package provides a cim logic used in CIM plugin


%package plugin-cim
Summary:        CIM plugin for %{product_family} image
Group:          Applications/System
Requires:       %{name}-plugin-cim-logic = %{version}-%{release}
Requires:       libvirt-cim
Requires:       sblim-sfcb

%description plugin-cim
This package provides a cim plugin for use with%{product_family} image.

%post plugin-cim
# Hack for rhbz#1018063
# The only time this is a problem is if we're upgrading from a pre-
# plugin version to a newer node. Manually specify the GID so we don't
# end up with a different one on the new image
if [[ ! `egrep '^cim' /etc/group` ]]; then
    # Create a group
    if [[ ! `egrep '^.*?:.*?:501:' /etc/group` ]]; then
        # gid 501 isn't taken
        groupadd -g 501 cim
    else
        # Take whatever GID we get -- probably no conflicts
        groupadd cim
    fi
fi
useradd -g cim -G sfcb -s /sbin/nologin cim
%if ! 0%{?is_systemd}
/sbin/chkconfig --add ovirt-cim
/sbin/chkconfig ovirt-cim on
%else
if [ $1 -eq 1 ] ; then
    # Initial installation
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
    /bin/systemctl enable ovirt-cim >/dev/null 2>&1 || :
fi
%endif
#CIM related changes
# set read-only
echo "readonly = true;" > /etc/libvirt-cim.conf

#cleanup tmp directory from cim setup
rm -rf /tmp/cim_schema*


%if 0%{?with_rhn}
%package plugin-rhn
Summary:        RHN plugin for %{product_family} image
Group:          Applications/System
Requires:       subscription-manager
Requires:       rhn-virtualization-host
Requires:       rhn-setup
Requires:       virt-who

%description plugin-rhn
This package provides the necessary rhn plugin tools for use with%{product_family} image.
%endif


#
# SELinux subpackage
#
%global selinux_modulename ovirt
%global selinux_variants targeted
%global selinux_policyver %_selinux_policy_version

%package selinux
Summary:          SELinux policy module supporting %{product_family}
Group:            System Environment/Base
BuildRequires:    policycoreutils, checkpolicy
BuildRequires:    selinux-policy-devel >= %{selinux_policyver}
BuildRequires:    /usr/share/selinux/devel/policyhelp, hardlink
%if "%{selinux_policyver}" != ""
Requires:         selinux-policy >= %{selinux_policyver}
%endif
Requires:         %{name} = %{version}-%{release}
Requires:         selinux-policy-base
Requires(post):   policycoreutils
Requires(postun): policycoreutils

%description selinux
SELinux policy module supporting %{product_family}

%post selinux
for selinuxvariant in %{selinux_variants}
do
  /usr/sbin/semodule -s ${selinuxvariant} -i \
    %{_datadir}/selinux/${selinuxvariant}/%{selinux_modulename}.pp
done
# Is this to greedy?
/sbin/restorecon -R / || :

# set SELinux booleans
# rhbz#502779 restrict certain memory protection operations
#     keep allow_execmem on for grub
# rhbz#642209 allow virt images on NFS
/usr/sbin/setsebool -P allow_execstack=0 \
                       virt_use_nfs=1 \
                       virt_use_sanlock=1 \
                       sanlock_use_nfs=1


%postun selinux
if [ $1 -eq 0 ] ; then
  for selinuxvariant in %{selinux_variants}
  do
     /usr/sbin/semodule -s ${selinuxvariant} -r %{selinux_modulename} &> /dev/null || :
  done
  # Is this to greedy?
  /sbin/restorecon -R / &> /dev/null || :
fi

# FIXME what about semanage?


#
# Igor service subpackage
#
%if 0%{?with_igor}
%package plugin-igor-slave
Summary:        Igor slave plugin for %{product_family}
Group:          Applications/System

Requires:       igor-common
%if 0%{?is_systemd}
BuildRequires:  systemd-units
Requires:       systemd
%else
BuildRequires:  initscripts
Requires(post): chkconfig
%endif

# We need python-uinput for TUI tests
Requires:       python-uinput


%description plugin-igor-slave
This package provides an igor service for %{product_family}. This service
is responsible for running testcase offered by an igor server.


%post plugin-igor-slave
%if 0%{?is_systemd}
if [ $1 -eq 1 ] ; then
    # Initial installation
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
    /bin/systemctl enable ovirt-node-igor-slave.service >/dev/null 2>&1 || :
fi
%else
/sbin/chkconfig --add ovirt-node-igor-slave >/dev/null 2>&1 || :
%endif


%preun plugin-igor-slave
%if ! 0%{?is_systemd}
if [ $1 = 0 ] ; then
    /sbin/service ovirt-node-igor-slave stop >/dev/null 2>&1
    /sbin/chkconfig --del ovirt-node-igor-slave
fi
%else
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable ovirt-node-igor-slave.service > /dev/null 2>&1 || :
    /bin/systemctl stop ovirt-node-igor-slave.service > /dev/null
fi
%endif

# </Igor service subpackage>
%endif



#
# oVirt Brand subpackage
#
%package branding-rhev
Summary:  Branding for oVirt Node
Group:    Applications/System

%description branding-rhev
This package contains the files to let Node appear in the RHEV look

#
# oVirt Node Lib
#
%package lib
Summary:         oVirt Node lib
BuildArch:       noarch
BuildRequires:   python-setuptools python-devel dracut
BuildRequires:   automake autoconf
Requires:        %{name}-lib-config = %{version}-%{release}
Requires:        %{name}-lib-legacy = %{version}-%{release}
Requires:        ethtool
Requires:        augeas >= 0.3.5
Requires:        bridge-utils
Requires(post):  /sbin/chkconfig
Requires(preun): /sbin/chkconfig
%if 0%{?is_systemd}
Requires:        systemd-units
Requires(post):  systemd-units
Requires(preun): systemd-units
Requires:        python-IPy
%endif
Requires:        iscsi-initiator-utils
Requires:        PyPAM
Requires:        python-urwid
Requires:        python-lockfile
Requires:        python-lxml
Requires:        rpm-python
Requires:        cracklib-python
Requires:        dracut
Requires:        tuned
Requires:        openssh-server
Requires:        python-gudev
Requires:        nfs-utils
Requires:        system-release
Requires:        ntp
Requires:        udev >= 147-2.34
Requires:        python-augeas
Requires:        hostname
Requires:        NetworkManager
%if 0%{?is_systemd}
Requires:       grub2
%else
Requires:       grub
# for applying patches in %post
Requires(post):       patch
%endif

#libvirt dependencies
Requires: libvirt-python
%if 0%{?rhel} >= 7 || 0%{?fedora} >= 18
Requires: libvirt-daemon >= 1.0.2-1
Requires: libvirt-daemon-config-nwfilter
Requires: libvirt-daemon-driver-network
Requires: libvirt-daemon-driver-nwfilter
Requires: libvirt-daemon-driver-qemu
%else
%if 0%{?rhel}
Requires: libvirt >= 0.10.2-18.el6_4.4
%else
Requires: libvirt >= 1.0.2-1
%endif
%endif

%description lib
The core source of oVirt Node


#
# oVirt Node Lib Config
#
%package lib-config
Summary:        oVirt Node core logic
BuildArch:      noarch
Requires:       system-config-keyboard-base
Requires:       %{name}-lib = %{version}-%{release}
Requires:       %{name}-lib-legacy = %{version}-%{release}

%description lib-config
All the logic for configuring the Node


#
# oVirt Node cli tools
#
%package cli-tools
Summary:        oVirt Node Cli Tools
BuildArch:      noarch
Requires:       %{name}-lib = %{version}-%{release}

%description cli-tools
Clients tools for oVirt Node


#
# oVirt Node Text User Interface (TUI) Installer
#
%package tui-installer
Summary:        oVirt Node TUI Installer
BuildArch:      noarch
Requires:       %{name}-lib = %{version}-%{release}
Requires:       %{name}-lib-config = %{version}-%{release}
Requires:       %{name}-lib-legacy = %{version}-%{release}

%description tui-installer
oVirt Node Text User Interface Installer


#
# oVirt Node Text User Interface (TUI) Setup
#
%package tui-setup
Summary:        oVirt Node TUI Setup
BuildArch:      noarch
Requires:       %{name}-lib = %{version}-%{release}
Requires:       %{name}-lib-config = %{version}-%{release}
Requires:       %{name}-plugin-snmp-logic = %{version}-%{release}
Requires:       %{name}-plugin-cim-logic = %{version}-%{release}

%description tui-setup
oVirt Node Text User Interface Setup


#
# oVirt Node Lib Legacy
#
%package lib-legacy
Summary:        oVirt Node Lib legacy
BuildArch:      noarch
Requires:       %{name}-lib = %{version}-%{release}
Requires:       %{name}-lib-config = %{version}-%{release}

%description lib-legacy
oVirt Node Legacy code


%prep
%setup -q -n"%{name}-%{?shortcommit}"

#%patch-marker
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1



%build
%if 0%{?use_snapshot}
./autogen.sh
%else
aclocal
autoheader || :
automake --add-missing
autoconf
%endif
%configure --with-image-minimizer
make

# Build SELinux policy module
cd semodule
for selinuxvariant in %{selinux_variants}
do
    %{__make} NAME=${selinuxvariant} \
        -f %{?policy_devel_root}%{_datadir}/selinux/devel/Makefile
    mv -v %{selinux_modulename}.pp %{selinux_modulename}.pp.${selinuxvariant}
done
cd -


%install
%{__rm} -rf %{buildroot}
make install DESTDIR=%{buildroot}
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/ovirt-node/hooks
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/ovirt-node/hooks/pre-upgrade
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/ovirt-node/hooks/post-upgrade
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/ovirt-node/hooks/rollback
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/ovirt-node/hooks/on-boot
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/ovirt-node/hooks/on-shutdown
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/ovirt-node/hooks/on-changed-boot-image

%if 0%{?is_systemd}
%{__install} -Dp -m0644 services/ntpd-pre-start.conf \
                       %{buildroot}%{_sysconfdir}/systemd/system/ntpd.service.d/ntpd-pre-start.conf
%{__install} -Dp -m0644 services/ntpd-private-tmp.conf \
                       %{buildroot}%{_sysconfdir}/systemd/system/ntpd.service.d/ntpd-private-tmp.conf
%else
# dracut patches for rhel6
%{__install} -p -m0644 dracut/dracut-7ed4ff0636c74a2f819ad6e4f2ab4862.patch %{buildroot}%{app_root}
%endif

# Install SELinux policy module
cd semodule
%{__install} -d %{buildroot}%{_datadir}/selinux
for selinuxvariant in %{selinux_variants}
do
    %{__install} -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
    %{__install} -p -m 644 %{selinux_modulename}.pp.${selinuxvariant} \
               %{buildroot}%{_datadir}/selinux/${selinuxvariant}/%{selinux_modulename}.pp
done
cd -

/usr/sbin/hardlink -cv %{buildroot}%{_datadir}/selinux

# Keep old name for backwards compatibilitiy reasons
ln -vfs %{_bindir}/ovirt-node-config-password %{buildroot}%{_libexecdir}/ovirt-config-password

# Remove igor stuff if not needed
%if ! 0%{?with_igor}
%{__rm} -vf %{buildroot}/%{_libexecdir}/ovirt-node-igor-slave \
            %{buildroot}/%{_unitdir}/ovirt-node-igor-slave.service \
            %{buildroot}/%{_initrddir}/ovirt-node-igor-slave
%endif

%{__rm} -vf %{buildroot}/%{_sbindir}/image-minimizer

# Remove rhn stuff if not needed
%if ! 0%{?with_rhn}
%{__rm} -vf %{buildroot}/%{python_sitelib}/ovirt/node/setup/rhn/* \
            %{buildroot}/%{_sysconfdir}/ovirt-commandline.d/rhn_autoinstall_args \
            %{buildroot}/%{_sysconfdir}/ovirt-config-boot.d/rhn_autoinstall.py*
rmdir %{buildroot}/%{python_sitelib}/ovirt/node/setup/rhn/
%endif



#
# Branding related stuff
#
# Add product certficate
%{__install} -p -m0644 %{SOURCE1} %{buildroot}%{app_root}/syslinux-vesa-splash.jpg

mkdir -p %{buildroot}/%{_sysconfdir}/pki/product/
%{__install} -p -m0644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/pki/product/

# Branding update to be RHEV
sed -i \
  -e "/^TUI_BRAND_COLOR/ s/blue/red/" \
  -e "/^[BR]OOT_SIZE/ s/[0-9]\+/4300/" \
  %{buildroot}/%{python_sitelib}/ovirt/node/presets.py
cat %{buildroot}/%{python_sitelib}/ovirt/node/presets.py


%clean
%{__rm} -rf %{buildroot}


%post
/sbin/chkconfig --level 35 netconsole off
%if ! 0%{?is_systemd}
/sbin/chkconfig --add ovirt-awake
/sbin/chkconfig --add ovirt-early
/sbin/chkconfig --add ovirt-firstboot
/sbin/chkconfig --add ovirt
/sbin/chkconfig --add ovirt-post
/sbin/chkconfig --add ovirt-kdump
%else
if [ $1 -eq 1 ] ; then
    # Initial installation
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
    /bin/systemctl --no-reload enable ovirt-firstboot.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload enable ovirt.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload enable ovirt-post.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload enable ovirt-early.service > /dev/null 2>&1 || :
fi
%endif
# workaround for imgcreate/live.py __copy_efi_files
if [ ! -e /boot/grub/splash.xpm.gz ]; then
  cp %{app_root}/grub-splash.xpm.gz /boot/grub/splash.xpm.gz
fi
%if ! 0%{?is_systemd}
# apply dracut fixes not in rhel6
# rhbz#683330
# dracut.git commits rediffed for dracut-004-336.el6
patch -d /usr/share/dracut/ -p0 < %{app_root}/dracut-7ed4ff0636c74a2f819ad6e4f2ab4862.patch

%endif

#Disable X11Forwarding for sshd
sed -i -e 's/X11Forwarding yes/X11Forwarding no/' /etc/ssh/sshd_config

#release info for dracut to pick it up into initramfs
# remove symlink to keep original redhat-release
rm -f /etc/system-release
echo "%{product_family} release %{version}" > /etc/system-release


%pre
#
# ovirt-node must not be upgraded.
# It is intended to only be installed.
# Upgrades happen on an image basis
#
if [[ $1 -eq 2 ]] ; then
    echo "Upgrade ovirt-node as a package is not supported."
    exit 42
fi


%preun
#
# ovirt-node must not be uninstalled.
# It is intended to only be installed.
# Upgrades happen on an image basis
#
echo "Upgrade/Uninstalling ovirt-node as a package is not supported."
exit 42

# Keeping the rest if it is possible one day
/sbin/chkconfig --level 35 netconsole off
%if ! 0%{?is_systemd}
if [ $1 = 0 ] ; then
    /sbin/service ovirt-early stop >/dev/null 2>&1
    /sbin/service ovirt-firstboot stop >/dev/null 2>&1
    /sbin/service ovirt stop >/dev/null 2>&1
    /sbin/service ovirt-post stop >/dev/null 2>&1
    /sbin/chkconfig --del ovirt-awake
    /sbin/chkconfig --del ovirt-early
    /sbin/chkconfig --del ovirt-firstboot
    /sbin/chkconfig --del ovirt
    /sbin/chkconfig --del ovirt-post
fi
%else
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable ovirt-firstboot.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload disable ovirt.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload disable ovirt-post.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload disable ovirt-early.service > /dev/null 2>&1 || :

    /bin/systemctl stop ovirt.service > /dev/null
    /bin/systemctl stop ovirt-post.service > /dev/null
    /bin/systemctl stop ovirt-early.service > /dev/null
fi
%endif


%preun plugin-cim
%if ! 0%{?is_systemd}
if [ $1 = 0 ] ; then
    /sbin/service ovirt-cim stop >/dev/null 2>&1
    /sbin/chkconfig --del ovirt-cim
fi
%else
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable ovirt-cim.service > /dev/null 2>&1 || :
    /bin/systemctl stop ovirt-cim.service > /dev/null
fi
%endif


#
# FILES
#
%files recipe
%defattr(0644,root,root,0755)
%doc README
%license COPYING
%{recipe_root}/*.ks
%defattr(0755,root,root,0755)
%{_mandir}/man8/node-creator.8.gz
%{_sbindir}/node-creator

%files lib-legacy
%{python_sitelib}/ovirt_config_setup/plugins.py*
%if ! 0%{?rhel}
%{python_sitelib}/ovirt_config_setup/collectd.py*
%endif
%{python_sitelib}/ovirt_config_setup/__init__.py*
%{python_sitelib}/ovirtnode/network.py*
%{python_sitelib}/ovirtnode/log.py*
%{python_sitelib}/ovirtnode/install.py*
%{python_sitelib}/ovirtnode/iscsi.py*
%{python_sitelib}/ovirtnode/ovirtfunctions.py*
%{python_sitelib}/ovirtnode/storage.py*
%{python_sitelib}/ovirtnode/password.py*
%{python_sitelib}/ovirtnode/__init__.py*

%files tui-setup
%{python_sitelib}/ovirt/node/setup/ipmi/ipmi_page.py*
%{python_sitelib}/ovirt/node/setup/ipmi/__init__.py*
%{python_sitelib}/ovirt/node/setup/core/network_page.py*
%{python_sitelib}/ovirt/node/setup/core/support_page.py*
%{python_sitelib}/ovirt/node/setup/core/security_page.py*
%{python_sitelib}/ovirt/node/setup/core/ping.py*
%{python_sitelib}/ovirt/node/setup/core/kdump_page.py*
%if ! 0%{?rhel}
%{python_sitelib}/ovirt/node/setup/core/monitoring_page.py*
%endif
%{python_sitelib}/ovirt/node/setup/core/diagnostics_page.py*
%{python_sitelib}/ovirt/node/setup/core/performance_page.py*
%{python_sitelib}/ovirt/node/setup/core/logging_page.py*
%{python_sitelib}/ovirt/node/setup/core/keyboard_page.py*
%{python_sitelib}/ovirt/node/setup/core/status_page.py*
%{python_sitelib}/ovirt/node/setup/core/remote_storage_page.py*
%{python_sitelib}/ovirt/node/setup/core/plugins_page.py*
%{python_sitelib}/ovirt/node/setup/core/__init__.py*
%{python_sitelib}/ovirt/node/setup/snmp/snmp_page.py*
%{python_sitelib}/ovirt/node/setup/snmp/__init__.py*
%{python_sitelib}/ovirt/node/setup/cim/cim_page.py*
%{python_sitelib}/ovirt/node/setup/cim/__init__.py*
%{python_sitelib}/ovirt/node/setup/__main__.py*
%{python_sitelib}/ovirt/node/setup/__init__.py*


%files tui-installer
%{python_sitelib}/ovirt/node/installer/core/storage_vol_page.py*
%{python_sitelib}/ovirt/node/installer/core/confirmation_page.py*
%{python_sitelib}/ovirt/node/installer/core/progress_page.py*
%{python_sitelib}/ovirt/node/installer/core/welcome_page.py*
%{python_sitelib}/ovirt/node/installer/core/installation_device_page.py*
%{python_sitelib}/ovirt/node/installer/core/password_page.py*
%{python_sitelib}/ovirt/node/installer/core/boot_device_page.py*
%{python_sitelib}/ovirt/node/installer/core/upgrade_page.py*
%{python_sitelib}/ovirt/node/installer/core/keyboard_page.py*
%{python_sitelib}/ovirt/node/installer/core/__init__.py*
%{python_sitelib}/ovirt/node/installer/__main__.py*
%{python_sitelib}/ovirt/node/installer/__init__.py*

%files cli-tools
%{python_sitelib}/ovirt/node/tools/features.py*
%{python_sitelib}/ovirt/node/tools/password.py*
%{python_sitelib}/ovirt/node/tools/__init__.py*

%files lib
%{python_sitelib}/ovirt/node/ui/__init__.py*
%{python_sitelib}/ovirt/node/ui/urwid_builder.py*
%{python_sitelib}/ovirt/node/ui/widgets.py*
%{python_sitelib}/ovirt/node/plugins.py*
%{python_sitelib}/ovirt/node/base.py*
%{python_sitelib}/ovirt/node/log.py*
%{python_sitelib}/ovirt/node/valid.py*
%{python_sitelib}/ovirt/node/loader.py*
%{python_sitelib}/ovirt/node/exceptions.py*
%{python_sitelib}/ovirt/node/app.py*
%{python_sitelib}/ovirt/node/__init__.py*
%{python_sitelib}/ovirt/__init__.py*
%{python_sitelib}/ovirt/node/utils/network.py*
%{python_sitelib}/ovirt/node/utils/firewall.py*
%{python_sitelib}/ovirt/node/utils/fs/mount.py*
%{python_sitelib}/ovirt/node/utils/fs/__init__.py*
%{python_sitelib}/ovirt/node/utils/security.py*
%{python_sitelib}/ovirt/node/utils/virt.py*
%{python_sitelib}/ovirt/node/utils/input.py*
%{python_sitelib}/ovirt/node/utils/hooks.py*
%{python_sitelib}/ovirt/node/utils/tuned.py*
%{python_sitelib}/ovirt/node/utils/process.py*
%{python_sitelib}/ovirt/node/utils/storage.py*
%{python_sitelib}/ovirt/node/utils/system.py*
%{python_sitelib}/ovirt/node/utils/expose.py*
%{python_sitelib}/ovirt/node/utils/console.py*
%{python_sitelib}/ovirt/node/utils/__init__.py*

%files lib-config
%{python_sitelib}/ovirt/node/config/network.py*
%{python_sitelib}/ovirt/node/config/defaults.py*
%{python_sitelib}/ovirt/node/config/tuned.py*
%{python_sitelib}/ovirt/node/config/__init__.py*
%{python_sitelib}/ovirt/node/config/migrate.py*


%files tools
%{_sbindir}/edit-node
%{_sbindir}/testable-node
%{_mandir}/man8/edit-node.8.gz

%files plugin-ipmi
%{python_sitelib}/ovirt/node/setup/ipmi/__init__.py*
%{python_sitelib}/ovirt/node/setup/ipmi/ipmi_page.py*

%files plugin-snmp-logic
%{python_sitelib}/ovirt/node/setup/snmp/snmp_model.py*

%files plugin-snmp
%{python_sitelib}/ovirt_config_setup/snmp.py*
%{python_sitelib}/ovirt/node/setup/snmp/__init__.py*
%{python_sitelib}/ovirt/node/setup/snmp/snmp_page.py*
%{_sysconfdir}/ovirt-plugins.d/snmp.minimize
%{_sysconfdir}/ovirt-config-boot.d/snmp_autoinstall.py*

%files plugin-cim-logic
%{python_sitelib}/ovirt/node/setup/cim/cim_model.py*

%files plugin-cim
%{python_sitelib}/ovirt_config_setup/cim.py*
%{python_sitelib}/ovirt/node/setup/cim/__init__.py*
%{python_sitelib}/ovirt/node/setup/cim/cim_page.py*
%{_sysconfdir}/ovirt-plugins.d/cim.minimize
%{_sysconfdir}/ovirt-commandline.d/cim-args
%{_sysconfdir}/ovirt-config-boot.d/cim_autoinstall.py*
%if 0%{?is_systemd}
%{_unitdir}/ovirt-cim.service
%else
%{_initrddir}/ovirt-cim
%endif

%if 0%{?with_igor}
%files plugin-igor-slave
%{_libexecdir}/ovirt-node-igor-slave
%if 0%{?is_systemd}
%{_unitdir}/ovirt-node-igor-slave.service
%else
%{_initrddir}/ovirt-node-igor-slave
%endif
%endif


%if 0%{?with_rhn}
%files plugin-rhn
%{python_sitelib}/ovirt/node/setup/rhn/__init__.py*
%{python_sitelib}/ovirt/node/setup/rhn/rhn_model.py*
%{python_sitelib}/ovirt/node/setup/rhn/rhn_page.py*
%{_sysconfdir}/ovirt-commandline.d/rhn_autoinstall_args
%{_sysconfdir}/ovirt-config-boot.d/rhn_autoinstall.py*
%endif


%files selinux
%defattr(-,root,root,0755)
%doc semodule/*.fc semodule/*.te
%{_datadir}/selinux/*/%{selinux_modulename}.pp


%files branding-rhev
%{python_sitelib}/ovirt/node/presets.py*
%{_sysconfdir}/pki/product/RHEV-*.pem



%files
%defattr(-,root,root)
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/default/ovirt

%config(noreplace) %{_sysconfdir}/logrotate.d/ovirt-node
%config(noreplace) %{_sysconfdir}/cron.d/ovirt-logrotate

%{mgmt_scripts_dir}
%dir %{_sysconfdir}/ovirt-config-boot.d
%{_sysconfdir}/ovirt-config-boot.d/local_boot_trigger.sh

%{_sysconfdir}/ovirt-node/logging.conf
%{_sysconfdir}/ovirt-node/logging.debug.conf
%{_sysconfdir}/sysconfig/modules/vlan.modules
%{_sysconfdir}/modprobe.d/ovirt-qla4xxx.conf
%{_sysconfdir}/modprobe.d/bonding.conf
%{_libexecdir}/ovirt-node/hooks

# Bundle libvirtd upstart conf: rhbz#1235350
%{app_root}/libvirtd.upstart

%license COPYING
# should be ifarch i386
%{app_root}/grub-splash.xpm.gz
# end i386 bits
%{app_root}/syslinux-vesa-splash.jpg
%if ! 0%{?is_systemd}
%{app_root}/dracut-7ed4ff0636c74a2f819ad6e4f2ab4862.patch

%endif

%{dracutdir}/91ovirtnode
%{_sysconfdir}/dracut.conf.d/ovirt-dracut.conf
%{_libexecdir}/ovirt-auto-install
%{_libexecdir}/ovirt-config-uninstall
%{_libexecdir}/ovirt-functions
%{_libexecdir}/ovirt-admin-shell
%{_libexecdir}/ovirt-config-password
%{_libexecdir}/ovirt-init-functions.sh
%{_libexecdir}/ovirt-node-hooks
%{_sbindir}/persist
%{_sbindir}/unpersist
%{_sbindir}/ovirt-node-upgrade
%{_sbindir}/ovirt-node-rebuild-initramfs
%{python_sitelib}/ovirt_config_setup
%exclude %{python_sitelib}/ovirt_config_setup/cim.py*
%exclude %{python_sitelib}/ovirt_config_setup/snmp.py*
%{python_sitelib}/ovirtnode
%{_sysconfdir}/ovirt-early.d
%dir %{_sysconfdir}/ovirt-commandline.d
%if 0%{?is_systemd}
%{_unitdir}/ovirt.service
%{_unitdir}/ovirt-awake.service
%{_unitdir}/ovirt-firstboot.service
%{_unitdir}/ovirt-post.service
%{_unitdir}/ovirt-early.service
%{_unitdir}/ovirt-kdump.service
%{_unitdir}/ovirt-node-hooks.service
%{_sysconfdir}/systemd/system/ntpd.service.d/ntpd-pre-start.conf
%{_sysconfdir}/systemd/system/ntpd.service.d/ntpd-private-tmp.conf
%else
%{_initrddir}/ovirt-awake
%{_initrddir}/ovirt-early
%{_initrddir}/ovirt-firstboot
%{_initrddir}/ovirt
%{_initrddir}/ovirt-post
%{_initrddir}/ovirt-kdump
%endif
# Files related to the new TUI
%{python_sitelib}/ovirt/__init__.py*
%{python_sitelib}/ovirt/node/*.py*
%{python_sitelib}/ovirt/node/ui/*.py*
%{_datadir}/locale/zh_CN/LC_MESSAGES/*.mo
%{_datadir}/locale/en_US/LC_MESSAGES/*.mo
%{_datadir}/locale/pt_BR/LC_MESSAGES/*.mo
%{python_sitelib}/ovirt/node/utils/*.py*
%{python_sitelib}/ovirt/node/utils/fs/*.py*
%{python_sitelib}/ovirt/node/tools/*.py*
%{python_sitelib}/ovirt/node/tools/*.xsl
%{python_sitelib}/ovirt/node/config/*.py*
%exclude %{python_sitelib}/ovirt/node/presets.py*
%{python_sitelib}/ovirt/node/setup/*.py*
%{python_sitelib}/ovirt/node/setup/core/*.py*
%{python_sitelib}/ovirt/node/installer/*.py*
%{python_sitelib}/ovirt/node/installer/core/*.py*
%exclude %{python_sitelib}/ovirt/node/setup/snmp/*.py*
%exclude %{python_sitelib}/ovirt/node/setup/cim/*.py*
%{_bindir}/ovirt-node-setup
%{_bindir}/ovirt-node-installer
%{_bindir}/ovirt-node-doc
%{_bindir}/ovirt-node-features
%{_bindir}/ovirt-node-config
%{_bindir}/ovirt-node-config-password



%changelog
* Thu Feb 25 2016 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.1-8
- Revert UEFI menu patches rhbz#1311800

* Mon Feb 22 2016 Ryan Barry <rbarry@redhat.com> - 3.6.1-7
- Start rhsmcertd rhbz#1269752

* Fri Feb 12 2016 Ryan Barry <rbarry@redhat.com> - 3.6.1-6
- Ensure /var/log/dmseg is up to date rhbz#1291643
- Fix the EFI CD boot menu rhbz#1302629
- Find grub configs on EFI rhbz#1046887

* Tue Jan 26 2016 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.1-5
- Apply patches

* Mon Jan 25 2016 Ryan Barry <rbarry@redhat.com> - 3.6.1-4
- Add EFI support back rhbz#1293490

* Wed Jan 13 2016 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.1-3
- Fix NIC configuration status rhbz#1280241
- Fix RHN related typo rhbz#1255277
- Add ebtables rule rhbz#1294517

* Wed Jan 06 2016 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.1-2
- Fix subscription-manager start after configuration rhbz#1269752

* Tue Dec 22 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.1-1
- Fix install storage requirement display rhbz#1153472
- Fix snmp activation rhbz#1261424
- Fix setting the password during upgrade rhbz#1263648
- Fix subscription manager registration detection rhbz#1280215
- Fix virt-who persistence rhbz#1209356

* Wed Dec 09 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.0-0.24
- Fix subscription rhbz#1276597

* Tue Dec 01 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.0-0.23
- Add some missed patches rhbz#1163756 rhbz#1267467
- Fix upgrade password issue rhbz#1263648
- Fix rhsmd start conditions rhbz#1269752

* Thu Nov 26 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.0-0.22
- Fix SSH Host key race rhbz#1248372
- Fix IPMI requirement rhbz#1281660
- Fix hook handler SELinux context rhbz#1281363
- Fix multipath.conf alignment (broke upgrades) rhbz#1275956
- Fix instaler typo rhbz#1264195
- Fix logging sensitivity rhbz#1283826
- Fix changing the hostname rhbz#1270736
- Fix listing of networks rhbz#1275226
- Satellite fixes rhbz#1278358 rhbz#1275222 rhbz#1280215
- Fix adding of iptables rules rhbz#1221999
- Fix wording for small screens rhbz#1214611
- Adjust open ports rhbz#1266530
- Fix SNMP config persistence rhbz#1261424
- Fix edit-node help rhbz#1269037
- Fix installer maximum size input rhbz#1270443
- Fix use fee space if set rhbz#1270448
- Fix initramfs rebuilding rhbz#1285607
- Fix virt-who persistence rhbz#1284934
- Fix double hook handler call

* Tue Nov 03 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.6.0-0.20
- Drop ALUA support from TUI rhbz#1273715
- Fix initramfs rebuild tool rhbz#1233106 rhbz#1275962

* Thu Oct 22 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.18
- Quick fix for syslog configuration rhbz#1273696
- Rough fix for the initramfs generation rhbz#1270228

* Wed Oct 21 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.16
- Fix libvirtd service race issues rhbz#1270203

* Tue Oct 20 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.15
- Drop NM dependency rhbz#1267470
- Fix RHN persistence rhbz#1259499
- Improve migration code rhbz#1224890
- Conditionalized rhn service start rhbz#1269752
- Check NIC existance during auto-install rhbz#1265175

* Tue Oct 13 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.14
- Revert a patch to address rhbz#1251151
- Contain the previously missed fix for rhbz#1267437

* Thu Oct 08 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.13
- Upstream rebase

* Mon Sep 28 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.10
- Upstream rebase

* Fri Sep 18 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.8
- Upstream rebase

* Thu Sep 17 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.6
- Upstream rebase

* Thu Sep 17 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.5
- Upstream rebase

* Sun Sep 06 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.4
- Upstream rebase

* Wed Sep 02 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.3
- Upstream rebase

* Wed Jul 22 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.2
- Upstream rebase

* Thu Jul 09 2015 Fabian Deutsch <fdeutsch@redhat.com> - 3.3.0-0.1
- Initial import of a pre-3.3 snapshot
